Package com.io7m.cardant.model

# Record Class CATypeDeclaration

java.lang.Object
java.lang.Record
com.io7m.cardant.model.CATypeDeclaration

Record Components:
  `name` - The type name
  `description` - The description
  `fields` - The set of fields

public record CATypeDeclaration(com.io7m.lanark.core.RDottedName name, String description, Map<com.io7m.lanark.core.RDottedName,CATypeField> fields) extends Record
A type declaration.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CATypeDeclaration(com.io7m.lanark.core.RDottedName name, String description, Map<com.io7m.lanark.core.RDottedName,CATypeField> fields)`
  A type declaration.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `description()`
  Returns the value of the `description` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `Map<com.io7m.lanark.core.RDottedName,CATypeField>`
  `fields()`
  Returns the value of the `fields` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `com.io7m.lanark.core.RDottedName`
  `name()`
  Returns the value of the `name` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CATypeDeclaration

    public CATypeDeclaration(com.io7m.lanark.core.RDottedName name, String description, Map<com.io7m.lanark.core.RDottedName,CATypeField> fields)
    A type declaration.
    Parameters:
      `name` - The type name
      `description` - The description
      `fields` - The set of fields

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### name

    public com.io7m.lanark.core.RDottedName name()
    Returns the value of the `name` record component.
    Returns:
      the value of the `name` record component

  - ### description

    public String description()
    Returns the value of the `description` record component.
    Returns:
      the value of the `description` record component

  - ### fields

    public Map<com.io7m.lanark.core.RDottedName,CATypeField> fields()
    Returns the value of the `fields` record component.
    Returns:
      the value of the `fields` record component